import { Container } from './Container';
import { DependencyProvider } from './types';
export declare type Factory<T, E> = (provider: E) => T;
export interface ILifetime<T, E> {
    readonly dependency: DependencyProvider<T, E>;
    readonly providerName: string;
    provide(): T;
}
export declare class Singleton<T, E> implements ILifetime<T, E> {
    readonly dependency: DependencyProvider<T, E>;
    readonly providerName: string;
    private value?;
    private readonly factoryFunction;
    private readonly container;
    constructor(container: Container<E>, dependency: DependencyProvider<T, E>, providerName: string, factoryFunction: Factory<T, E>);
    provide(): T;
}
export declare class Transient<T, E> implements ILifetime<T, E> {
    readonly dependency: DependencyProvider<T, E>;
    readonly providerName: string;
    private readonly factory;
    private container;
    constructor(container: Container<E>, dependency: DependencyProvider<T, E>, providerName: string, factoryFunction: Factory<T, E>);
    provide(): T;
}
