import { Keys } from './utils';
export declare type DependencyProvider<T, E> = {
    prototype: T;
    name: string;
    new (provider: E): T;
} | {
    prototype: T;
    name: string;
    new (): T;
};
export declare type NameSelector<T, E> = (provider: Keys<T, E>) => string;
export declare enum DependencyErrorType {
    Existence = "'{name}' has not been added to dependency container, but it was supposed to, wasn't it?",
    Circular = "'{name}' has circular dependency, two dependencies cannot depend on each other no matter how long the chain is between them",
    Duplicate = "'{name}' has already been added to dependency container, use tryAdd if you might be adding it in multiple places",
    Unknown = "'{name}' has not been included as key in the provider, if classname differ from provider name remember to select it via name in the options parameter"
}
export declare enum DependencyMultiErrorType {
    Build = "Found errors while building provider\n{errors}",
    Validation = "Provider validation failed with\n{errors}"
}
