"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DependencyMultiErrorType = exports.DependencyErrorType = void 0;
var DependencyErrorType;
(function (DependencyErrorType) {
    DependencyErrorType["Existence"] = "'{name}' has not been added to dependency container, but it was supposed to, wasn't it?";
    DependencyErrorType["Circular"] = "'{name}' has circular dependency, two dependencies cannot depend on each other no matter how long the chain is between them";
    DependencyErrorType["Duplicate"] = "'{name}' has already been added to dependency container, use tryAdd if you might be adding it in multiple places";
    DependencyErrorType["Unknown"] = "'{name}' has not been included as key in the provider, if classname differ from provider name remember to select it via name in the options parameter";
})(DependencyErrorType = exports.DependencyErrorType || (exports.DependencyErrorType = {}));
var DependencyMultiErrorType;
(function (DependencyMultiErrorType) {
    DependencyMultiErrorType["Build"] = "Found errors while building provider\n{errors}";
    DependencyMultiErrorType["Validation"] = "Provider validation failed with\n{errors}";
})(DependencyMultiErrorType = exports.DependencyMultiErrorType || (exports.DependencyMultiErrorType = {}));
